var RELEASE =false;
var URL_PREFIX = RELEASE ? "https://mpay.fuiou.com:16128/" : "http://www-1.fuiou.com:18880/mobile_pay/";			

$.extend({
	tempUrl:'1',
	tempHud:'1',
	tempSuccess:'1',
	tempFailed:'1',
	urlParam: function(name) {
		name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
		var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
			results = regex.exec(location.search);
		return results === null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
	},
	createLoadingTip: function() {
		var opts = {
			lines: 9,
			length: 0,
			width: 6,
			radius: 12,
			corners: 1,
			rotate: 0,
			direction: 1,
			color: '#4c4a4a',
			speed: 1,
			trail: 85,
			shadow: false,
			hwaccel: false,
			className: 'spinner',
			zIndex: 29,
			top: '50%',
			left: '50%'
		};
		var spinner = new Spinner(opts); //实例化loading图案
		var target = $("#loading").get(0);
		spinner.spin(target);
		return spinner;
	},
	createXML: function(data) {
		var xmlStr = "";
		for (var propertyName in data) {
			if (data.hasOwnProperty(propertyName)) {
				if (typeof propertyName != 'function') {
					xmlStr += ("<" + propertyName + ">" + data[propertyName] + "</" + propertyName + ">")
				}
			}
		}
		xmlStr += "<RspType>1</RspType>";
		return "<FM>" + xmlStr + "</FM>";
	},
	httpPost: function httpPost(url, data, hud, success, failed) {
		var spinner = $.createLoadingTip();
		if (!RELEASE) {
			console.info(this.createXML(data));
		}
		this.tempSuccess = success;
		this.tempFailed = failed;
		this.tempUrl = url;
		this.tempHud = hud;
		window.fypay.encry(url, this.createXML(data));
	},
	httpPostImpl: function httpPostImpl(url, data) {
		var spinner = $.createLoadingTip();
		if (!RELEASE) {
			console.info(data);
		}		
		var oThis = this;
		return $.ajax({
			url: URL_PREFIX + url,
			contentType: "application/x-www-form-urlencoded;charset=utf-8",
			type: "GET",
			scriptCharset:"utf-8",
			data: {
				FMS: data
			},
			dataType: "jsonp",
			jsonp: 'callback',
			async: true,
			crossDomain: true,
			xhrFields: {
				withCredentials: false
			},
			success: function(msg) {
				if (!RELEASE) {
					console.info('fm   = ' + msg.rcd);
					console.info('fm   = ' + msg.rDesc);
					console.info('fm   = ' + JSON.stringify(msg));
				}
				if (msg.rcd == '0000') {
					msg.rDesc = '֧支付成功';
					oThis.tempSuccess(msg);
				} else {
					msg.rcd = '9999';
					msg.extraData = msg.rDesc;
					msg.rDesc = '֧支付失败';
					oThis.tempFailed(msg.extraData);
				}
			},
			timeout: 60000,
			error: function(XMLHttpRequest, textStatus, errorThrown) {
				oThis.tempFailed("请求失败,网络不给力!");
				console.log("XMLHttpRequest:" + XMLHttpRequest.status + "||XMLHttpRequest.readyState:" + XMLHttpRequest.readyState + "||textStatus:" + textStatus + "||errorThrown:" + errorThrown);
			},
			beforeSend: function(xhr) {
				if (oThis.tempHud) {
					var target = $("#loading").get(0);
					spinner.spin(target);
				}
			},
			complete: function() {
				if (oThis.tempHud) {
					spinner.spin();
					$('.loading').hide();
				}
			}
		});
	}
});